"use client"
import NextLink from "next/link"
import { usePathname } from "next/navigation"

import { linkVariants } from "./variants"

import type { LinkProps } from "./link"

export default function Link({
  className,
  color,
  href,
  partialMatch = false,
  size,
  prefetch,
  variant,
  ...props
}: LinkProps) {
  const currentPageSlug = usePathname()
  let isActive = currentPageSlug === href
  if (partialMatch && !isActive) {
    isActive = currentPageSlug.startsWith(href)
  }
  const classNames = linkVariants({
    active: isActive,
    className,
    color,
    size,
    variant,
  })
  return (
    <NextLink
      prefetch={prefetch}
      className={classNames}
      href={href}
      {...props}
    />
  )
}
